
    define{
        void = nothing
        float= real
        SetUnitZ(u,z) = SetUnitFlyHeight(u,z,99999)
        }
    bzvector3d LastCreatedVector3d = 0
    bzvector2d LastCreatedVector2d = 0
    struct bzvector3d{
        float vx
        float vy
        float vz
    }
    struct bzvector2d{
        float vx
        float vy
    }
    
    define BzLastCreatedVector3d(void) = LastCreatedVector3d
    define BzLastCreatedVector2d(void) = LastCreatedVector2d
    
    void BzSetVector3d(bzvector3d v,float x,float y,float z ){
        v.vx = x
        v.vy = y
        v.vz = z
    }
    void BzSetVector2d( bzvector2d v,float x,float y){
        v.vx = x
        v.vy = y
    }
    define{ 
        GetVectorX3d(vc) = vc##.vx
        GetVectorY3d(vc) = vc##.vy
        GetVectorZ3d(vc) = vc##.vz
        }
    
    bzvector3d BzCreateVector3d(float vx,float vy,float vz){
        bzvector3d New = bzvector3d.create()
        New.vx = vx
        New.vx = vy
        New.vz = vz
        LastCreatedVector3d = New 
        return New
    }
    bzvector2d BzCreateVector2d(float vx,float vy){
        bzvector2d New = bzvector2d.create()
        New.vx = vx
        New.vy = vy
        LastCreatedVector2d = New 
        return New
    }
    bzvector2d BzCreateVector2dEx(real d,real u){
        bzvector2d New = bzvector2d.create()
        New.vx = d*Cos(0.017453278*u)
        New.vy = d*Sin(0.017453278*u)
        LastCreatedVector2d = New 
        return New
    }
    bzvector3d BzCopy3d(bzvector3d v){
        bzvector3d New = bzvector3d.create()
        New.vx = v.vx
        New.vy = v.vy
        New.vz = v.vz
        return New
    }
    bzvector2d BzCopy2d(bzvector2d v){
        bzvector2d New = bzvector2d.create()
        New.vx = v.vx
        New.vy = v.vy
        return New
    }
    define BzModule3d(r) = (SquareRoot(s__bzvector3d_vx[r]*s__bzvector3d_vx[r]+s__bzvector3d_vy[r]*s__bzvector3d_vy[r]+s__bzvector3d_vz[r]*s__bzvector3d_vz[r]))
    define BzModule2d(r) = (SquareRoot(s__bzvector3d_vx[r]*s__bzvector3d_vx[r]+s__bzvector3d_vy[r]*s__bzvector3d_vy[r]))
    
    void BzVc3d(bzvector3d a, float const){
        a.vx = a.vx*const
        a.vy = a.vy*const
        a.vz = a.vz*const
    }
    
    void BzVc2d(bzvector2d a,float const){
        a.vx = a.vx*const
        a.vy = a.vy*const
    }

    define CosV3d(a,b) =((s__bzvector3d_vx[a]*s__bzvector3d_vx[b]+s__bzvector3d_vy[a]*s__bzvector3d_vy[b]+s__bzvector3d_vz[a]*s__bzvector3d_vz[b])/(BzModule3d(a)*BzModule3d(b)))
    define CosV2d(a,b) =((s__bzvector3d_vx[a]*s__bzvector3d_vx[b]+s__bzvector3d_vy[a]*s__bzvector3d_vy[b])/(BzModule3d(a)*BzModule3d(b)))
    
    float BzAngleGr3d(bzvector3d a, bzvector3d b){
        return Acos((a.vx*b.vx + a.vy*b.vy + a.vz*b.vz)/(BzModule3d(a)*BzModule3d(b)))*57.29577951
    }
    
    float BzAngleGr2d(bzvector2d a, bzvector2d b){
        return Acos((a.vx*b.vx + a.vy*b.vy)/(BzModule2d(a)*BzModule2d(b)))*57.29577951
    }
    
    void BzSummV3d(bzvector3d a, bzvector3d b){
        a.vx = a.vx + b.vx
        a.vy = a.vy + b.vy
        a.vz = a.vz + b.vz   
    }
      
    void BzSummV2d(bzvector2d a, bzvector2d b){
        a.vx = a.vx + b.vx
        a.vy = a.vy + b.vy  
    }

    define BzScalar3d(a,b) = (s__bzvector3d_vx[a]*s__bzvector3d_vx[b]+s__bzvector3d_vy[a]*s__bzvector3d_vy[b]+s__bzvector3d_vz[a]*s__bzvector3d_vz[b])
    define BzScalar2d(a,b) = (s__bzvector3d_vx[a]*s__bzvector3d_vx[b]+s__bzvector3d_vy[a]*s__bzvector3d_vy[b])

    define BzDestroyVector3d(v) = bzvector3d.destroy(v)
    define BzDestroyVector2d(v) = bzvector2d.destroy(v)
    
    void MoveUnit2d(unit u,bzvector2d a){
        SetUnitX(u,GetUnitX(u) + s__bzvector2d_vx[a])
        SetUnitY(u,GetUnitY(u) + s__bzvector2d_vy[a])
    }

    void MoveUnit3d(unit u,bzvector3d a){
        float x = GetUnitX(u) + s__bzvector3d_vx[a]
        float y = GetUnitY(u) + s__bzvector3d_vy[a]
        SetUnitX(u,x)
        SetUnitY(u,y)
        MoveLocation(a_loc,x,y)
        SetUnitFlyHeight(u,GetUnitFlyHeight(u)-GetLocationZ(a_loc)+s__bzvector3d_vz[a],999999)
        }

/*     Variable */
        hashtable     Mv_htbl_all##        =  InitHashtable()
        location      a_loc##              =  Location(0,0)
        
        timer         Mv_unit_new_tm##     =  null
        timer         Mv_unit_new_tm##2    =  null
        
        float array   Mv_unit_new_rtm## 
        float array   Mv_unit_new_rtm##2
        
        trigger array Mv_Trg_cmez_##0z
        trigger array Mv_Trg_cmez_##1z
        
        group         Mv_unit_new_gp##       =  CreateGroup()
        group         Mv_unit_new_gp##2        =  CreateGroup()
        
        integer       Mv_unit_counter##       =  0
        integer       Mv_unit_counter##2      =  0
        
        unit          Bz_tf_mvng2##1         = null
        unit          Bz_tf_mvng2##2         = null
        
        
        integer array Item11_1,Item11_2,Item11_3,Item11_4,Item11_5,Item11_6;
        
        integer array ITEM_a
        integer array ITEM_LIMIT
        
        integer        Bz_item_iiii            = 0
        
/*     EndVariable */
    
    define{
        GetBz_tf_mvng21(nothing) = Bz_tf_mvng21
        GetBz_tf_mvng22(nothing) = Bz_tf_mvng22
    
    }
    
    void tf_mvng(){
        unit u = GetEnumUnit()
        integer id = GetHandleId(u)
        bzvector2d St = LoadInteger(Mv_htbl_all,id,1)
        float Time =  Mv_unit_new_rtm[St]
        
        if (Time < 0){
            bzvector2d.destroy(St)
            SaveInteger(Mv_htbl_all,id,1,0)
            Mv_unit_new_rtm[St] = 0
            GroupRemoveUnit(Mv_unit_new_gp,u)
            Mv_unit_counter = Mv_unit_counter - 1
            
            if (Mv_unit_counter == 0) {
               DestroyTimer(Mv_unit_new_tm)
               Mv_unit_new_tm = null
            }
        }else{
            Mv_unit_new_rtm[St] = Mv_unit_new_rtm[St] - 0.035
            SetUnitX(u,GetUnitX(u)+St.vx)
            SetUnitY(u,GetUnitY(u)+St.vy)
        }
        u = null
    }

    void Gr_start(){
        ForGroup(Mv_unit_new_gp,function tf_mvng)
    }
    
    void MoveUnitV( unit u,bzvector2d a, float time ){
        integer wd = GetHandleId(u)
        integer id = LoadInteger(Mv_htbl_all,wd,1)
    if (id == 0){
        Mv_unit_counter++
        GroupAddUnit(Mv_unit_new_gp,u)
        SaveInteger(Mv_htbl_all,wd,1,a)
        Mv_unit_new_rtm[a] = time
    }else{
        bzvector2d.destroy(id)
        SaveInteger(Mv_htbl_all,wd,1,a)
        Mv_unit_new_rtm[a] = time
    }
    if Mv_unit_new_tm == null{
        Gr_start()
        Mv_unit_new_tm = CreateTimer()
        TimerStart(Mv_unit_new_tm,0.035,true,function Gr_start)
    }
    }

    void tf_mvng2(){
        unit u  = GetEnumUnit()
        integer key =GetHandleId(u)
    
        unit u2 = LoadUnitHandle(Mv_htbl_all,key,3)
        float X1 = GetUnitX(u)
        float Y1 = GetUnitY(u)
    
        float X2 = GetUnitX(u2)
        float Y2 = GetUnitY(u2)
    
        float Mov1 =SquareRoot((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        float Mov = LoadReal(Mv_htbl_all,key,4)/(Mov1)
    
        if (Mov1 > 50){
            SetUnitX(u,X1+(X2-X1)*Mov)
            SetUnitY(u,Y1+(Y2-Y1)*Mov)
        }else{
            Bz_tf_mvng21 = u
            Bz_tf_mvng22 = u2
            TriggerExecute(LoadTriggerHandle(Mv_htbl_all,key,5))
            SaveTriggerHandle(Mv_htbl_all,key,5,null)
            SaveUnitHandle(Mv_htbl_all,key,3,null)
            SaveReal(Mv_htbl_all,key,4,0)
            GroupRemoveUnit(Mv_unit_new_gp2,u)
            Mv_unit_counter2--
            
            if (Mv_unit_counter2 == 0){
                DestroyTimer(Mv_unit_new_tm2)
                Mv_unit_new_tm2 = null
            }
        }
        u = null
        u2= null
    }

    void Gr_start2(){
        ForGroup(Mv_unit_new_gp2,function tf_mvng2)
    }
    
    void UmoveUnitc(unit u,unit u2,float sila,trigger t){
        integer wd = GetHandleId(u)
    
        GroupAddUnit(Mv_unit_new_gp2,u)
        SaveUnitHandle(Mv_htbl_all,wd,3,u2)
        SaveReal(Mv_htbl_all,wd,4,sila)
        SaveTriggerHandle(Mv_htbl_all,wd,5,t)
    
        Mv_unit_counter2++
        if (Mv_unit_new_tm2 == null){
            Gr_start2()
            Mv_unit_new_tm2 = CreateTimer()
            TimerStart(Mv_unit_new_tm2,0.035,true,function Gr_start2)}
    }

   void BzFly(unit u){
       UnitAddAbility   (u,'Amrf')
       UnitRemoveAbility(u,'Amrf')
   }
   
    float BzGetZ(float x,float y){
        MoveLocation(a_loc,x,y)
        return GetLocationZ(a_loc)
    }
    
    void BzSetUnitXYZ(unit u,float x,float y,float z){
        SetUnitX(u,x)
        SetUnitY(u,y)
        MoveLocation(a_loc,x,y)
        SetUnitZ(u,z-GetLocationZ(a_loc))
    }


